/*
    Monitor source code for CDP1802 Microprocessor Kit 2018
    (C) 2018 by Wichit Sirichote
	Xtal frequency 3.6864MHz, 32kB RAM, 28kB ROM, 4 kB memory mapped I/O
	ROM 0-6FFF,
	I/O 7000-7FFF
	RAM 8000

*/

// prototype declaration

void key_dump();
void pstr(char *s);
void read_record1();


volatile unsigned char *gpio1 = (unsigned char*) 0x7000;
volatile unsigned char *segment = (unsigned char*) 0x7102;
volatile unsigned char *digit = (unsigned char*) 0x7101;
volatile unsigned char *port0 = (unsigned char*) 0x7100;
volatile unsigned char *port1 = (unsigned char*) 0x7101;
volatile unsigned char *port2 = (unsigned char*) 0x7102;

volatile unsigned char *uart_buffer = (unsigned char*) 0x7300;
volatile unsigned char *uart_line_status = (unsigned char*) 0x7305;
volatile unsigned char *uart_fifo = (unsigned char*) 0x7302;
volatile unsigned char *uart_lcr = (unsigned char*) 0x7303;
volatile unsigned char *uart_divisor_lsb = (unsigned char*) 0x7300;
volatile unsigned char *uart_divisor_msb = (unsigned char*) 0x7301;
volatile unsigned char *uart_scr = (unsigned char*) 0x7307;

volatile unsigned char *LCD_cwr = (unsigned char*) 0x7200;
volatile unsigned char *LCD_dwr = (unsigned char*) 0x7201;
volatile unsigned char *LCD_crd = (unsigned char*) 0x7202;
volatile unsigned char *LCD_drd = (unsigned char*) 0x7203;

volatile unsigned char *tick = (unsigned char*) 0xffff;

#define BUSY 0x80



char convert[16]= {0xBD,0x30,0x9B,0xBA,0x36,0xAE,0xAF,0x38,0xBF,0xBE,0x3F,0xA7,0x8D,0xB3,0x8F,0x0F};

char text1[]={"\r\n\n\n\nCDP1802 MICROPROCESSOR KIT 2018"};
char text2[]={"CDP1802 KIT-----"};
char text3[]={"32k RAM 9600UART"};
char text4[]={"\r\nLoad Intel Hex file..waiting"};
char text5[]={"\r\nBye check sum error!"};
char text6[]={"\r\n0 error..."};









//---------------------------- utility subroutines ---------------------------------------------
// user delay subroutine will be loaded into RAM at location F000
// to use it, load register with F001, the set it to be program counter
char user_delay[]={0xD0,0xF8,0x64,0xA6,0xF8,00,0xA7,0x27,0x87,0x3A,07,0x26,0x86,0x3A,04,0x30,00};

// interrupt service routine @ F020
char interrupt_test[]={0xF8,0xF0,0xB1,0xF8,0x38,0xA1,0xF8,0x70,0xB4,0xF8,00,0xA4,0xF8,
0xFF,0xB6,0xF8,0xFF,0xA6,0xE0,0x70,0x00,0x30,0x35,0x70,0x22,0x78,0x06,0xFC,01,0x56,0xFB,
	0x0A,0x3A,0x46,0x56,0x15,0x85,0x54,0xC4,0x30,0x37};





char n,c,t,hit;


int i,j,k;
int temp;
unsigned int warm;

char flag;


char bcc, save_bcc, bcc_error, record_type;


char o,q,key;
char key_pressed;
char buffer[6];

int temp,temp16,timeout;
int num, start, end, desti;


unsigned int PC, save_PC;

char state,x,hit;

char *dptr;
char *dptr2;

char user_d, user_df, user_xp;
int user_r3,user_r4,user_r5,user_r6,user_r7,user_r8,user_r9,user_r10;
int user_r11,user_r12,user_r13,user_r14,user_r15;




void delay_num1()
{
  temp=0;
  temp=0;
}

void delay_ms(unsigned int w)
{
	unsigned int n;
  for( n = 0; n < w; n++)
	  ;

}

void blink_q()
{
	asm(" seq \n");
		delay_ms(100);
	asm(" req \n");
		delay_ms(2000);

	asm(" seq \n");
		delay_ms(100);
	asm(" req \n");
		delay_ms(2000);
}


char scan(){

    k = 1;

	key = 0xff;
	q = 0;

   for(i=0; i<6; i++)
   {
     *digit = ~k;

	 *segment = buffer[i];

	 if(buffer[i] != 0x30 && buffer[i] != 0x38 && buffer[i] != 0x70) delay_ms(3);
	 else delay_num1();

	 *segment = 0;

	//  delay_ms(1);

	  o= *port0;

	 for(n=0; n<6; n++)
	 {
	   if((o&1)==0)
		 {key=q;


		 }

	   else q++;
	   o = o >> 1;
	 }

	  k = k << 1;
  }

      key_pressed=key;

	 //  *gpio1=key;


	 return key_pressed;

}


void dot_address()
{
 buffer[0]=buffer[0]&~0x40;
	buffer[1]=buffer[1]&~0x40;


		buffer[2]=buffer[2]|0x40;
			buffer[3]=buffer[3]|0x40;
				buffer[4]=buffer[4]|0x40;
				buffer[5]=buffer[5]|0x40;

}


void dot_data()
{

 	buffer[0]=buffer[0]|0x40;
	buffer[1]=buffer[1]|0x40;

	buffer[2]=buffer[2]&~0x40;
			buffer[3]=buffer[3]&~0x40;
				buffer[4]=buffer[4]&~0x40;
				buffer[5]=buffer[5]&~0x40;

}

void hex4(int h)
{
    temp16 = h;
	buffer[2]= convert[temp16&0xf];
	temp16>>=4;
	buffer[3]= convert[temp16&0xf];
	temp16>>=4;
	buffer[4]=convert[temp16&0xf];
	temp16>>=4;
	buffer[5]=convert[temp16&0xf];
}


void address_display()
{

	temp16 = PC;

	hex4(temp16);

}

void data_display()
{
    dptr = (char *)PC;

	n = *dptr;

	buffer[0]= convert[n&0xf];
	n = n>>4;
	buffer[1]=convert[n&0xf];
}

void read_memory()
{
    address_display();
	data_display();
}


void key_address()
{


	state = 1;

  	read_memory();


    dot_address();
	hit=0;




 }

void key_data()
{

	read_memory();
    dot_data();
    hit=0;
	state=2;

}

void key_plus()
{

     if(state==1 || state==2)
     {
       PC++;
       read_memory();
	   key_data();
	  }

    if(state==5)
	{
     state=6;
	 start = num;
	 hit=0;
	 buffer[0]=0x8f;  /* end cursor */
	 return;

	}

	if(state==6)
	{
      state=7;
	 end = num;
	 hit=0;
	 buffer[0]=0xb3;  /* destination cursor */

	// if(end <= start) print_error();




	}



}

void key_minus()
{
   if(state==1 | state ==2)
   {
    PC--;
    read_memory();
	key_data();
   }
}

void data_hex()
{

   dptr = (char *)PC;
	x = *dptr;
	if(hit==0) x=0;
	{
	 hit =1;
	 x = x << 4;
	 x = x|key;

	 *dptr = x;

	 read_memory();

     dot_data();
	}
}

void key_PC()
{
     PC=save_PC;
	 key_data();
}

void hex_address()
{
    if(hit==0) PC=0;
	{
	   hit=1;

	   PC<<=4;
	   PC |= key;
	   read_memory();
	   dot_address();
	}
}

/* insert byte and shift 512 bytes down */

void insert()
{
	dptr=(char *)PC;
    for(j=512; j>0; j--)
	{
	 *(dptr+j)=*(dptr+j-1);
	}
	*(dptr+1)=0;  /* insert next byte */
	PC++;
    read_memory();
	state=2;
}


/* delete current byte and shift 512 bytes up */

void cut_byte()
{
  	dptr=(char *)PC;
    for(j=0; j<512; j++)
	{
	 *(dptr+j)=*(dptr+j+1);
	}
    read_memory();
	state=2;
}

void key_go(){

	if(state==1 || state==2)
	{

		asm("	ldAD r5,_PC \n"
	        "    ldn r5 \n"
            "    phi  r0 \n"
            "    inc r5  \n"
            "    ldn r5  \n"
			"    plo r0  \n"
			"    sep r0\n"
	        );

	}

	if(state==7)
		{
        desti = num;
		temp = end-start;
		dptr = (char *)start;
		dptr2 = (char *) desti;

		for(i=0; i<temp; i++)
		{
			*(dptr2+i)=*(dptr+i);
		}
		PC = desti;
        read_memory();
        dot_data();
		state=2;





		}

}

void key_test()
{

	PC = 0xf020;  // test 10ms timer SW1 selects 10ms

	state = 1;

	key_go();


}

void key_load()
{

  pstr(text4);
  read_record1();

  if(bcc_error) pstr(text5);
    else pstr(text6);

	 PC = 0x8000;
	key_data();



}

void key_reg()
{
   buffer[5]= 0x03;
   buffer[4]= 0x8F;
   buffer[3]= 0xad;
   buffer[2]=0;
   buffer[1]=0;
   buffer[0]=0;

   state = 3;    /* register display state = 3 with hex key */

}



void reg_d()
{

    n = user_d;

	buffer[2]= convert[n&0xf];
	n = n>>4;
	buffer[3]=convert[n&0xf];
	buffer[4]=0;
	buffer[5]=0;
	buffer[1]=0;
	buffer[0]=0xb3;   // reg d
}

void reg_df()
{

    n = user_df;  // DF =  0 or 1

	buffer[2]= 0;
	buffer[3]=convert[n&0xf];
	buffer[4]=0;
	buffer[5]=0;
	buffer[1]=0xb3;   // flag DF
	buffer[0]=0x0f;   //
}

void reg_xp()
{

    n = user_xp;  // xp

	buffer[2]= convert[n&0xf];
	n = n>>4;

	buffer[3]=convert[n&0xf];
	buffer[4]=0;
	buffer[5]=0;
	buffer[1]=0x13;   // XP
	buffer[0]=0x1F;   //
}

void reg_r3()
{

    hex4(user_r3);

	buffer[1]=0x03;
	buffer[0]=0xba;
}

void reg_r4()
{

    hex4(user_r4);  //

	buffer[1]=0x03;   //
	buffer[0]=0x36;
}

void reg_r5()
{

    hex4(user_r5);  //

	buffer[1]=0x03;   //
	buffer[0]=0xae;
}

void reg_r6()
{

    hex4(user_r6);  //

	buffer[1]=0x03;   //
	buffer[0]=0xaf;
}

void reg_r7()
{

    hex4(user_r7);  //

	buffer[1]=0x03;   //
	buffer[0]=0x38;
}

void reg_r8()
{

    hex4(user_r8);  //

	buffer[1]=0x03;   //
	buffer[0]=0xbf;
}
void reg_r9()
{

    hex4(user_r9);  //

	buffer[1]=0x03;   //
	buffer[0]=0xbe;
}
void reg_r10()
{

    hex4(user_r10);  //

	buffer[1]=0x03;   //
	buffer[0]=0x3f;
}
void reg_r11()
{

    hex4(user_r11);  //

	buffer[1]=0x03;   //
	buffer[0]=0xa7;
}
void reg_r12()
{

    hex4(user_r12);  //

	buffer[1]=0x03;   //
	buffer[0]=0x8d;
}
void reg_r13()
{

    hex4(user_r13);  //

	buffer[1]=0x03;   //
	buffer[0]=0xb3;
}

void reg_r14()
{

    hex4(user_r14);  //

	buffer[1]=0x03;   //
	buffer[0]=0x8f;
}

void reg_r15()
{

    hex4(user_r15);  //

	buffer[1]=0x03;   //
	buffer[0]=0x0f;
}




void reg_display()
{

  switch(key)
	{
   case 0: reg_d(); break;
   //case 1: reg_df(); break;  // future work
   //case 2: reg_xp(); break;
   case 3: reg_r3(); break;
   case 4: reg_r4(); break;
   case 5: reg_r5(); break;
   case 6: reg_r6(); break;
   case 7: reg_r7(); break;
   case 8: reg_r8(); break;
   case 9: reg_r9(); break;
   case 10: reg_r10(); break;
   case 11: reg_r11(); break;
   case 12: reg_r12(); break;
   case 13: reg_r13(); break;
   case 14: reg_r14(); break;
   case 15: reg_r15(); break;

    }
}


void enter_num()
{
   if(hit==0) num=0;
	{
	   hit=1;

	   num<<=4;
	   num |= key;
	   hex4(num);

	}
}

void clear_buffer()
{
	for(i=0; i<6; i++)
		*(buffer+i)=0;
}


void key_copy()
{


	state=5;
		hit=0;
		clear_buffer();
        buffer[2]= 0xbd;

		buffer[0]=0xae;
		buffer[1]=0;


}





/* return internal code hex keys and function keys  */

char key_code(char n)
{
	char d;
	if(n == 0x10) return 0;
	if(n == 0x21) return 1;
	if(n == 0x1b) return 2;
	if(n == 0x15) return 3;
	if(n == 0x16) return 4;
	if(n == 0x20) return 5;
	if(n == 0x1a) return 6;
	if(n == 0x14) return 7;
	if(n == 0x1c) return 8;
	if(n == 0x1f) return 9;
	if(n == 0x19) return 0xa;
	if(n == 0x13) return 0xb;
	if(n == 0x22) return 0xc;
	if(n == 0x1e) return 0xd;
	if(n == 0x18) return 0xe;
	if(n == 0x12) return 0xf;

	if(n == 0xc) return 0x10;  // pc
	if(n == 0xd) return 0x11;  // reg
	if(n == 0xe) return 0x12;  // data
	if(n == 0xf) return 0x13;  // address

	if(n == 6) return 0x14;
	if(n == 7) return 0x15;  // MUTE
	if(n == 8) return 0x16;  // -
	if(n == 9) return 0x17;  // +

	if(n == 0) return 0x18;  // load
	if(n == 1) return 0x19;  // insert
	if(n == 2) return 0x1a;  // delete
	if(n == 3) return 0x1b;  // go

    if(n == 0x13) return 0x1c;
	if(n == 0x1d) return 0x1d; // test
	if(n == 0x17) return 0x1e; // dump
	if(n == 0x00) return 0x1f;
	if(n == 0x23) return 0x20; // copy

	return 0xff;

}


void delay_beep()
{
   for(j=0; j<2; j++)
   continue;
}


void beep()
{

   *port2=0;

   for(x=0; x<60; x++)
   {
   *port1 = (char) ~0x80;
    delay_beep();
   *port1 = 0xff;
    delay_beep();
   }

}

void key_mute()
{
    flag ^=1;
}

void key_qled()
{

	while(1)
	{
	asm(" seq \n");
	delay_ms(500);
	asm(" req \n");



    delay_ms(30000);
	}
}


void key_exe()
{

  if(flag==0) beep();

 if( key>15)
	{
  if(key==0x13) key_address();
  if(key==0x12) key_data();
  if(key==0x17) key_plus();
  if (key==0x16) key_minus();
  if (key==0x10) key_PC();
  if (key==0x1b) key_go();
  if (key==0x11) key_reg();
  if (key==0x19) insert();
  if (key==0x1a) cut_byte();
  if (key==0x1e) key_dump();
  if (key==0x1d) key_test();
  if (key==0x18) key_load();
  if (key==0x20) key_copy();
  if (key==0x15) key_mute();
  if (key==0x14) key_qled();


  	}

 else
	{
	 switch(state)
		{

  case 1: hex_address(); break;
  case 2: data_hex(); break;
  case 3: reg_display(); break;
  case 5: enter_num(); break;
  case 6: enter_num(); break;
  case 7: enter_num(); break;
        }

	}

}

void scan1(){

		while(scan() != 0xff)
			;
		delay_ms(10);

		while(scan() == 0xff)
			;
		delay_ms(5);

		key = scan();

		key = key_code(key);

	//	*gpio1=key;   // debug

		if((key>=0) && (key <0x30))	 key_exe();
}

//------------------------------- UART --------------------------------

void init_8250()
{
    *uart_lcr = 0x83;
	*uart_divisor_lsb = 24;  // computed for 3.6864MHz
	*uart_divisor_msb = 0;
	 *uart_fifo =7;
     *uart_lcr = 3;
}

void cout(char n)
{
	while((*uart_line_status & 0x20)==0)
		;
	*uart_buffer=n;
}

char cin()
{
	while((*uart_line_status & 1)==0)
		;
	c =	*uart_buffer;

   return c;
}

void pstr(char *s)
{
	 while( *s )
		 {
               cout(*s);
               s++;
        }
}

void test_uart()
{

   for(c=0x20; c<0x80; c++)
	   cout(c);
}

void newline()
{
	cout(0x0a);
	cout(0x0d);
}

void send_hex(char n)
{
   k = n>>4;
   k = k&0xf;

   if (k>9) cout(k+0x37); else cout(k+0x30);
   k= n&0xf;
   if (k>9) cout(k+0x37); else cout(k+0x30);
}

void send_word_hex(int n)
{
   temp16 = n>>8;
   k = temp16&0xff;
   send_hex(k);
   k = n&0xff;
   send_hex(k);
}



void key_dump()
{
   int j,p;

   dptr = (char *)PC;

   for(j=0; j<16; j++)
   {
     newline();
     send_word_hex(PC);
     cout(':');
        for(p=0; p<16; p++)
        {

         send_hex(*(dptr+p));
         cout(0x20);
         }

        cout(0x20);

        for (p=0; p<16; p++)
        {
          q=*(dptr+p);
         if(q >= 0x20 && q < 0x80) cout(q);
          else cout('.');

        }


         dptr+=16;
		 PC+=16;
   }
   newline();
     // PC = dptr;
   key_address();
}


char nibble2hex(char c)
{
	char n;
  if(c<0x40) return (c-0x30);
  else return (c-0x37);
}

char gethex()
{
  char a,b;

  a = cin();
  b = cin();

  a = nibble2hex(a)<<4;
  b = nibble2hex(b);
  a = a|b;
  bcc = bcc+a;  /* compute check sum */

  return (a);
}

int get16bitaddress()
{
  unsigned int load_address;

  load_address =0;

  load_address |= gethex();
  load_address <<=8;
  load_address |= gethex();

  return load_address;
}


// read Intel hex record
// :20 0000 00 71F8FFB2F8F0A2F800B3F814A37BD37AD3300DD0F864A6F800A727873A1A2686EB

void read_record1()
{

   char x;
   char byte_count;

   int address16bit;

   bcc_error=0;

  do{


   bcc =0;

   while(cin()!= ':')
	   ;


   byte_count = gethex();  /* only data record */

   	dptr = (char *) get16bitaddress();

	record_type= gethex();

	// now read byte

  for(x=0; x<byte_count; x++)
   {
    *(dptr+x) = gethex();
   }

  // bcc = gethex();
 //  bcc = ~bcc;   /* one's complement */
//   bcc+= bcc;  // two's complement

   *gpio1=bcc;    /* loading indicator */


//	save_bcc= bcc;

 // if(save_bcc != gethex()) bcc_error=1;

  }

  while(record_type==0);


}


//---------------------------------------------------------------------



//---------------------------- LCD drivers ------------------------------


/*   LCD driver   */

void LcdReady()
{
   timeout=0;

   while(((*LCD_crd&0x80)==1) && (timeout<500))
    ++timeout;
}

void clr_screen()
{
    LcdReady();
	 *LCD_cwr=0x01;
}


void goto_xy(int x, int y)
{
    LcdReady();

    switch(y)
	{
	case 0: *LCD_cwr=0x80+x; break;
    case 1: *LCD_cwr=0xC0+x; break;
    case 2: *LCD_cwr=0x94+x; break;
    case 3: *LCD_cwr=0xd4+x; break;
    }
}


void InitLcd()
{
    LcdReady();
    *LCD_cwr=0x38;
    LcdReady();
    *LCD_cwr=0x0c;
    clr_screen();
    goto_xy(0,0);
	delay_ms(100);
}


void PutLCD(char *str)
{
    char i;
    for (i=0; str[i] != '\0'; i++)
	{
    LcdReady();
    *LCD_dwr=str[i];
    }


}

void putch_lcd(char ch)
{
    LcdReady();
    *LCD_dwr=ch;
}
//------------------------- end of LCD drivers ----------------------------

void load_user_subroutines()
{
	PC = 0xf000;
	dptr = (char *) PC;

	for (i=0; i<17 ;i++ )
	{
     *(dptr+i) = user_delay[i];
     }

    PC = 0xf020;

	dptr = (char *) PC;

	for (i=0; i<sizeof(interrupt_test) ;i++ )
	{
     *(dptr+i) = interrupt_test[i];
     }



}




void service_break()
{

   asm(
	   " plo r2     ; save D first \n"
       " ldAD r1, _USER_D \n"
       " glo r2 \n"
       " str r1 \n"

       " ldAD r1, _USER_R3 \n"
       " ghi r3 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r3 \n"
       " str r1 \n"

       " ldAD r1, _USER_R4\n"
       " ghi r4 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r4 \n"
       " str r1 \n"

       " ldAD r1, _USER_R5\n"
       " ghi r5 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r5 \n"
       " str r1 \n"

       " ldAD r1, _USER_R6\n"
       " ghi r6 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r6 \n"
       " str r1 \n"

       " ldAD r1, _USER_R7\n"
       " ghi r7 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r7 \n"
       " str r1 \n"

	   " ldAD r1, _USER_R8\n"
       " ghi r8 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r8 \n"
       " str r1 \n"

	   " ldAD r1, _USER_R9\n"
       " ghi r9 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r9 \n"
       " str r1 \n"

	   " ldAD r1, _USER_R10\n"
       " ghi r10 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r10 \n"
       " str r1 \n"

	   " ldAD r1, _USER_R11\n"
       " ghi r11 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r11 \n"
       " str r1 \n"

	   " ldAD r1, _USER_R12\n"
       " ghi r12 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r12 \n"
       " str r1 \n"

	   " ldAD r1, _USER_R13\n"
       " ghi r13 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r13 \n"
       " str r1 \n"

	   " ldAD r1, _USER_R14\n"
       " ghi r14 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r14 \n"
       " str r1 \n"

	   " ldAD r1, _USER_R15\n"
       " ghi r15 \n"
       " str r1 \n"
       " inc r1 \n"
       " glo r15 \n"
       " str r1 \n"

       " lbr 0    ; return to system monitor\n"

	   );

}

void main()
{

	*segment = 0;
	*digit = 0xff;
	*gpio1 = 0;

	*tick=0;

	state =0;

    init_8250();
    InitLcd();

	if(warm != 0xaaaa)
	{

     flag =0;
	 warm = 0xaaaa;
	}



	blink_q();

	 PC = 0x8000;
     save_PC = 0x8000;

//	 asm("	ldAD r1,9000h \n");    // load interrupt vector at 9000h


     load_user_subroutines();

	 dptr= (char *) PC;

    // test_uart();

	PutLCD(text2);
	goto_xy(0,1);
    PutLCD(text3);

	 pstr(text1);



	buffer[0]=0;
	buffer[1]=0;
	buffer[2]=convert[2];
	buffer[3]=convert[0];
	buffer[4]=convert[8];
	buffer[5]=convert[1];

	while(1){

         scan1();
	}
}

void setRAM()
{
   asm("ROM_END1:  EQU  $\n");
   asm("    org 0fe00h\n");  // space for monitor variables
}




